package pucrs.hslcommunicationservice.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import pucrs.hslcommunicationservice.domain.Announcement;
import pucrs.hslcommunicationservice.service.AnnouncementService;

import java.util.List;

@RestController
@RequestMapping("/announcement")
public class AnnouncementController {

    @Autowired
    private AnnouncementService announcementService;

    @PostMapping
    public Announcement postAnnouncement(
            @RequestBody Announcement announcement
    ) {
        return announcementService.addAnnouncement(announcement);
    }

    @GetMapping
    public List<Announcement> getAnnouncements(
            @RequestParam(required = false) Long idDepartment,
            @RequestParam(required = false) Integer page,
            @RequestParam(required = false) Integer pageSize
    ) {
        if (page != null || pageSize != null) {
            if (idDepartment == null) {
                return announcementService.getAnnouncements(page, pageSize);
            } else {
                return announcementService.getAnnouncementsByDepartment(idDepartment, page, pageSize);
            }
        } else {
            if (idDepartment == null) {
                return announcementService.getAnnouncements();
            } else {
                return announcementService.getAnnouncementsByDepartment(idDepartment);
            }
        }
    }

    @GetMapping("/{id}")
    public Announcement getAnnouncement(
            @PathVariable Long id
    ) {
        return announcementService.getAnnouncementById(id);
    }

}