package pucrs.hslcommunicationservice.domain;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.annotations.Proxy;

import javax.persistence.*;

@Entity
@Table(name = "users")
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonIgnoreProperties({"hibernateLazyInitializer", "handler"})
@Proxy(lazy = false)
public class User {

    @Id
    @Column(nullable = false)
    private Long registry;

    @Column(nullable = false)
    private String name;

    @Column(nullable = false)
    private boolean isAdmin;

    @Column(nullable = false)
    private int day;

    @Column(nullable = false)
    private int month;

    @ManyToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "idDepartment", referencedColumnName = "id")
    private Department department;

    @Column
    private boolean active;

    @Column
    private String email;

    @Column
    private String phone;

    @Column(nullable = false)
    private String occupation;

}
