package pucrs.hslcommunicationservice.service;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import pucrs.hslcommunicationservice.domain.Department;
import pucrs.hslcommunicationservice.repository.DepartmentRepository;

import java.util.List;

@Service
public class DepartmentService {

    @Autowired
    private DepartmentRepository departmentRepository;

    public Department addDepartment(Department department) {
        return departmentRepository.save(department);
    }

    public Department getDepartmentById(Long id) {
        return departmentRepository.getById(id);
    }

    public Department getDepartamentByName(String name) {
        return departmentRepository.findAll()
                .stream()
                .filter(dep -> dep.getName().equals(name))
                .findFirst()
                .orElseThrow();
    }

    public List<Department> getDepartments() {
        return departmentRepository.findAll();
    }

}
