package pucrs.hslcommunicationservice.service;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import pucrs.hslcommunicationservice.aws.SESClient;
import pucrs.hslcommunicationservice.domain.Message;
import pucrs.hslcommunicationservice.domain.User;

@Service
public class MessageService {

    @Autowired
    private UserService userService;

    @Autowired
    private DepartmentService departmentService;

    @Autowired
    private SESClient sesClient;

    public Message sendMessage(Message message) {
        String departamentEmail = departmentService.getDepartamentByName(message.getDepartmentName()).getEmail();
        sesClient.sendEmail(departamentEmail, buildSubject(message), message.getContent());
        return message;
    }

    public String buildSubject(Message message) {
        User user = userService.getUserByRegistry(message.getRegistry());
        return message.getTitle() + " - Enviado por: " + user.getName() + " do departamento: " + user.getDepartment().getName();
    }

}
